SystemOrganization addCategory: #'SwaUtil-Widgets'!
SystemOrganization addCategory: #SwaUtil!

ScrollBar subclass: #SwaGeneralScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaGeneralScrollBar commentStamp: 'mt 12/15/2009 14:27' prior: 0!
Extracted from Polymorph. Support for GeneralScrollPane.!

!SwaGeneralScrollBar methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:45'!
setValue: newValue
	"Bypass screwed up scrollbar!!"
	
	^self perform: #setValue: withArguments: {newValue} inSuperclass: Slider! !

!SwaGeneralScrollBar methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:33'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

!CompiledMethod class methodsFor: '*SwaUtil' stamp: 'bs 11/27/2009 16:37'!
fromQualifiedName: aQualifiedName! !

!CompiledMethod methodsFor: '*SwaUtil-override' stamp: 'bs 12/22/2009 10:21'!
getSourceFor: selector in: class
	| unstyledSource styledSource |
	unstyledSource := self getUnstyledSourceFor: selector in: class.
	styledSource := SwaSourceTextStyler instance styleSource: unstyledSource of: self.
	^ styledSource.! !

!CompiledMethod methodsFor: '*SwaUtil' stamp: 'bs 12/22/2009 09:32'!
getUnstyledSourceFor: selector in: class
	"Retrieve or reconstruct the source code for this method."
	| flagByte source |
	flagByte := self last.
	(flagByte = 0
		or: [flagByte = 251 "some source-less methods have flag = 251, rest = 0"
			and: [((1 to: 3) allSatisfy: [:i | (self at: self size - i) = 0])]])
		ifTrue:
		["No source pointer -- decompile without temp names"
		^ (class decompilerClass new decompile: selector in: class method: self)
			decompileString].
	flagByte < 252 ifTrue:
		["Magic sources -- decompile with temp names"
		^ ((class decompilerClass new withTempNames: self tempNamesString)
				decompile: selector in: class method: self)
			decompileString].

	"Situation normal;  read the sourceCode from the file"
	
	source := [self getSourceFromFile]
				on: Error
		"An error can happen here if, for example, the changes file has been truncated by an aborted download.  The present solution is to ignore the error and fall back on the decompiler.  A more thorough solution should probably trigger a systematic invalidation of all source pointers past the end of the changes file.  Consider that, as time goes on, the changes file will eventually grow large enough to cover the lost code, and then instead of falling into this error case, random source code will get returned."
				do: [ :ex | ex return: nil].
		
	^source
		ifNotNil: [
			| sourceSelector |
			"I think this is something to do with the traits system.  It would be ncie if someone
			 documented this.  It looks like an egregious hack to me. eem 9/5/2009 09:04"
			(class isAliasSelector: selector)
				ifFalse: [ source ]
				ifTrue: [ "Only alias selectors need this replacement"
					 sourceSelector := Parser parserClass new parseSelector: source.
					 sourceSelector = selector
						ifTrue: [ source ]
						ifFalse: [ self replace: sourceSelector with: selector in: source ] ] ]
		ifNil: [
			"Something really wrong -- decompile blind (no temps)"
			 (class decompilerClass new decompile: selector in: class method: self)
				decompileString]! !

!CompiledMethod methodsFor: '*SwaUtil' stamp: 'bs 11/20/2009 11:54'!
qualifiedName
	^ self methodClass name, ' >> #', self selector ! !

Object subclass: #SwaSourceTextStyler
	instanceVariableNames: 'registeredStylers'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'SwaUtil'!

!SwaSourceTextStyler class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 10:46'!
instance
	^ Instance
		ifNil: [Instance := super new]! !

!SwaSourceTextStyler class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 09:42'!
new
	"Singleton, use #instance"
	^ self error: 'Use #instance'! !

!SwaSourceTextStyler methodsFor: 'registration' stamp: 'bs 12/22/2009 10:35'!
registerStyler: aStyler
	self registeredStylers add: aStyler! !

!SwaSourceTextStyler methodsFor: 'accessing' stamp: 'bs 12/22/2009 10:36'!
registeredStylers
	^ registeredStylers ifNil: [registeredStylers := OrderedCollection new]! !

!SwaSourceTextStyler methodsFor: 'styling' stamp: 'bs 12/22/2009 10:10'!
styleSource: aText of: aCompiledMethod
	| styledSourceText |
	styledSourceText := aText.
	self registeredStylers do: [ :styler | 
		styledSourceText := styler styleSource: styledSourceText of: aCompiledMethod ].
	^ styledSourceText.! !

!SwaSourceTextStyler methodsFor: 'registration' stamp: 'bs 12/22/2009 09:58'!
unregisterStyler: aStyler
	self registeredStylers remove: aStyler! !

Morph subclass: #SwaGeneralScrollPane
	instanceVariableNames: 'scroller hScrollbar vScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaGeneralScrollPane commentStamp: 'mt 12/15/2009 14:27' prior: 0!
Extracted from Polymorph. A scroll pane that handles its contents accurately.!

!SwaGeneralScrollPane class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:50'!
defaultScrollbarThickness

	^ Preferences scrollBarsNarrow
		ifTrue: [10]
		ifFalse: [14]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 16:03'!
adoptPaneColor: paneColor
	"Adopt the given pane color."
	
	super adoptPaneColor: paneColor.
	self hScrollbar adoptPaneColor: paneColor.
	self vScrollbar adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: (self scrollTarget isNil
		ifTrue: [self paneColor]
		ifFalse: [self scrollTarget color])
! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:23'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^ Color transparent! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:43'!
defaultScrollTarget
	"Answer a new default scroll target."

	^RectangleMorph new
		extent: 200@150! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 11:06'!
extent: newExtent
	"Update the receiver's extent. Hide/show the scrollbars and resize the scroller
	as neccessary."
	
	|scrollbarChange|
	bounds extent = newExtent ifTrue: [^ self].
	super extent: newExtent.
	scrollbarChange := (self vScrollbarShowing = self vScrollbarNeeded) not.
	scrollbarChange := scrollbarChange or: [(self hScrollbarShowing = self hScrollbarNeeded) not].
	self	updateScrollbars.
	scrollbarChange ifFalse: [self resizeScroller] "if there is a scrollbar change then done already"! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
fitScrollTarget
	"If the scroller is bigger than the scroll target then
	resize the scroll target to fill the scroller."
	
	|extra|
	extra := 0.
	self scroller width > self scrollTarget width
		ifTrue: [self scrollTarget width: self scroller width]
		ifFalse: [extra := self scrollBarThickness].
	self scroller height - extra > self scrollTarget height
		ifTrue: [self scrollTarget height: self scroller height + extra]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
hHideScrollbar
	"Hide the horizontal scrollbar."
	
	self hScrollbarShowing ifFalse: [^self].
	self removeMorph: self hScrollbar.
	self vResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:31'!
hPageDelta
	"Answer the horizontal page delta."
	
	|pd tw sw|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
hResizeScrollbar
	"Resize the horizontal scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b top: b bottom - self scrollBarThickness.
	self vScrollbarShowing ifTrue: [
		b := b right: b right - self scrollBarThickness].
	self hScrollbar bounds: b! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar
	"Answer the value of hScrollbar"

	^ hScrollbar! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar: anObject
	"Set the value of hScrollbar"

	hScrollbar := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:37'!
hScrollbarInterval
	"Answer the computed size of the thumb of the horizontal scrollbar."
	
	^self scrollBounds width asFloat / self scrollTarget width min: 1.0.! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
hScrollbarNeeded
	"Return whether the horizontal scrollbar is needed."
	
	^self scrollTarget width > self innerBounds width! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:07'!
hScrollbarShowing
	"Answer whether the horizontal scrollbar is showing."
	
	^self hScrollbar owner notNil
	! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:34'!
hScrollbarValue
	"Answer the computed horizontal scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset x asFloat / v min: 1.0].
	^v! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
hScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget width - self scrollBounds width max: 0.
	self scroller
		offset: (r * scrollValue) rounded @ self scroller offset y! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:36'!
hSetScrollDelta
	"Set the horizontal scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self hPageDelta.
	self hScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self hScrollbarInterval;
		setValue: self hScrollbarValue! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
hShowScrollbar
	"Show the horizontal scrollbar."
	
	self hResizeScrollbar.
	self hScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self hScrollbar atIndex: 1.
	self vResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 12/9/2008 12:06'!
hUpdateScrollbar
	"Update the visibility and dimensions of the horizontal scrollbar as needed."
	
	self hScrollbarNeeded
		ifTrue: [self
					hShowScrollbar;
					hResizeScrollbar]
		ifFalse: [self hHideScrollbar]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
handlesKeyboard: evt
	"Yes for page up/down."
	
	^true! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 1/28/2008 16:49'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^true! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 21:11'!
hideOrShowScrollBars
	"Requested by slider. See ScrollBar>>#mouseDownInSlider:"! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scroller: self newScroller;
		hScrollbar: self newHScrollbar;
		vScrollbar: self newVScrollbar;
		scrollTarget: self defaultScrollTarget.
	self
		addMorph: self scroller;
		resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
keyStroke: evt
	"If pane is not empty, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	(self scrollByKeyboard: evt) ifTrue: [^self].
	self scrollTarget keyStroke: evt! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 1/28/2008 16:55'!
mouseWheel: event 
	"Handle a mouseWheel event."
	
	(self scrollTarget handlesMouseWheel: event)
		ifTrue: [^self scrollTarget mouseWheel: event]. "pass on"
	event direction = #up ifTrue: [
		vScrollbar scrollUp: 3].
	event direction = #down ifTrue: [
		vScrollbar scrollDown: 3]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:31'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^SwaGeneralScrollBar new
		model: self;
		setValueSelector: #hScrollbarValue:! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:50'!
newScroller
	"Answer a new scroller."

	^TransformMorph new
		color: Color transparent! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:31'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^SwaGeneralScrollBar new
		model: self;
		setValueSelector: #vScrollbarValue:! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:57'!
resizeScroller
	"Resize the scroller to fit the scroll bounds."
	
	self scroller bounds: self scrollBounds! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:47'!
scrollBarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self scrollbarThickness! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
scrollBounds
	"Return the visible scroll area taking into account whether
	the scrollbars need to be shown."
	
	|b|
	b := self innerBounds.
	self vScrollbarNeeded ifTrue: [b := b right: (b right - self scrollBarThickness)].
	self hScrollbarNeeded ifTrue: [b := b bottom: (b bottom - self scrollBarThickness)].
	^b! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 14:07'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true."
	
	|sb|
	sb _ event commandKeyPressed
		ifTrue: [self hScrollbar]
		ifFalse: [self vScrollbar].
	(event keyValue = 30 or: [event keyValue = 11]) ifTrue: [
		sb scrollUp: 3.
		^true].
	(event keyValue = 31 or: [event keyValue = 12])ifTrue: [
		sb scrollDown: 3.
		^true].
	^false! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:48'!
scrollTarget
	"Answer the morph that is scrolled."
	
	^self scroller submorphs first! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:48'!
scrollTarget: aMorph
	"Set the morph that is scrolled."
	
	self scroller
		removeAllMorphs;
		addMorph: aMorph.
	self updateScrollbars! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2008 10:19'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	|offset|
	offset := self scroller offset.
	((aRectangle top - offset y) >= 0 and: [
		(aRectangle bottom - offset y) <= self innerBounds height])
		ifFalse: [offset := offset x @ (
					(aRectangle top min: self scrollTarget height - self innerBounds height))].
	((aRectangle left - offset x) >= 0 and: [
		(aRectangle right - offset x) <= self innerBounds width])
		ifFalse: [offset := (aRectangle left min: self scrollTarget width - self innerBounds width) @ offset y].
	offset = self scroller offset ifFalse: [
		self scroller offset: offset.
		self setScrollDeltas]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:51'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self class defaultScrollbarThickness! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller
	"Answer the value of scroller"

	^ scroller! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller: anObject
	"Set the value of scroller"

	scroller := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
setScrollDeltas
	"Set the ScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	
	self
		hSetScrollDelta;
		vSetScrollDelta! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
updateScrollbars
	"Update the visibility, dimensions and values of the scrollbars as needed."
	
	self
		vUpdateScrollbar;
		hUpdateScrollbar;
		setScrollDeltas! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
vHideScrollbar
	"Hide the vertical scrollbar."
	
	self vScrollbarShowing ifFalse: [^self].
	self removeMorph: self vScrollbar.
	self hResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:47'!
vLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	
	^self scrollTarget height - self scrollBounds height max: 0
! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vPageDelta
	"Answer the vertical page delta."
	
	|pd tw sw|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
vResizeScrollbar
	"Resize the vertical scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b left: b right - self scrollBarThickness.
	self hScrollbarShowing ifTrue: [
		b := b bottom: b bottom - self scrollBarThickness].
	self vScrollbar bounds: b! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar
	"Answer the value of vScrollbar"

	^ vScrollbar! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar: anObject
	"Set the value of vScrollbar"

	vScrollbar := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vScrollbarInterval
	"Answer the computed size of the thumb of the vertical scrollbar."
	
	^self scrollBounds height asFloat / self scrollTarget height min: 1.0.! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
vScrollbarNeeded
	"Return whether the vertical scrollbar is needed."
	
	^self scrollTarget height > self innerBounds height! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:15'!
vScrollbarShowing
	"Answer whether the vertical scrollbar is showing."
	
	^self vScrollbar owner notNil
	! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:50'!
vScrollbarValue
	"Answer the computed vertical scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset y asFloat / v min: 1.0].
	^v! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
vScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget height - self scrollBounds height max: 0.
	self scroller
		offset: self scroller offset x @ (r * scrollValue) rounded! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:52'!
vSetScrollDelta
	"Set the vertical scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self vPageDelta.
	self vScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self vScrollbarInterval;
		setValue: self vScrollbarValue! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
vShowScrollbar
	"Show the vertical scrollbar."
	
	self vResizeScrollbar.
	self vScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self vScrollbar atIndex: 1.
	self hResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:03'!
vUpdateScrollbar
	"Update the visibility and dimensions of the vertical scrollbar as needed."
	
	self vScrollbarNeeded
		ifTrue: [self
				vShowScrollbar;
				vResizeScrollbar]
		ifFalse: [self vHideScrollbar]! !
